<?php
/*
(c) Copyright: soft.vomske.ru
*/

// ensure this file is being included by a parent file
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$sp_sape_user         = trim($params->get( 'sp_sape_user' ));
$sp_fetch_remote_type = trim($params->get( 'sp_fetch_remote_type' ));
$sp_charset           = trim($params->get( 'sp_charset' ));
$sp_redirect_url      = trim($params->get( 'sp_redirect_url' ));
$sp_show_header       = trim($params->get( 'sp_show_header' ));
$sp_debug_mode        = trim($params->get( 'sp_debug_mode' ));
$sp_link_count        = trim($params->get( 'sp_link_count' ));
$moduleclass_sfx      = $params->get( 'moduleclass_sfx' );
$sp_hide_empty	      = trim($params->get( 'sp_hide_empty' ));
$sp_show_host         = trim($params->get( 'sp_show_host' ));
$sp_show_host_text    = trim($params->get( 'sp_show_host_text' ));
$sp_sape_site_id           = trim($params->get( 'sp_sape_site_id' ));
//$sp_server= $params->get( 'sp_server' );
if (!defined('_SAPE_USER')){
  unset($sape_option);
  switch ($sp_fetch_remote_type) {
    case "1" :
      $sape_option['fetch_remote_type']= 'file_get_contents'; 
    break;
    case "2" :
      $sape_option['fetch_remote_type']= 'curl'; 
    break;
    case "3" :
      $sape_option['fetch_remote_type']= 'socket'; 
    break;
  }
  
  switch ($sp_charset) {
    case "1" :
      $sape_option['charset']= 'CP1251'; 
    break;
    case "2" :
      $sape_option['charset']= 'UTF-8'; 
    break;
  }

  if ($sp_show_host==='1' and isset($sp_show_host_text)){
    $sape_option['host'] = $sp_show_host_text;
  }

  if ($sp_redirect_url==='1' and isset($_SERVER['REDIRECT_URL'])){
    $sape_option['request_uri'] = $_SERVER['REDIRECT_URL'];
  }

  if ($sp_redirect_url==='2' and isset($_SERVER['SCRIPT_URL'])){
    $sape_option['request_uri'] = $_SERVER['SCRIPT_URL'];
  }

  global $mod_sape_return_links;
  global $mod_sape_debug_count;
  $mod_sape_debug_count=1;
  define('_SAPE_USER', $sp_sape_user); 
  require_once($_SERVER['DOCUMENT_ROOT'].'/'._SAPE_USER.'/sape.php');
  if (isset($sape_option)) {
    $mod_sape_return_links = new SAPE_client($sape_option); 
  } else{
    $mod_sape_return_links = new SAPE_client(); 
  }
}else{
  global $mod_sape_return_links;
  global $mod_sape_debug_count;
  $mod_sape_debug_count++;
}

if ($sp_debug_mode==='1' or $sp_debug_mode==='2'){
  if ($sp_link_count==='0'){
    $sp_link_count_st='';
  } else{
    $sp_link_count_st=$sp_link_count;
  }
  echo "<h1>  $mod_sape_debug_count : $sp_link_count_st</h1>";
  echo '<p align="left">  : </p>';
  echo '<hr />';
  if (isset($sape_option['request_uri'])) {
    echo '<p align="left">Request_uri      sape: <b>'.$sape_option['request_uri'].'</b></p><hr />';
  }
  if (isset($_SERVER['REQUEST_URI'])) {
    echo '<p align="left">$_SERVER[\'REQUEST_URI\'] : <b>'.$_SERVER['REQUEST_URI'].'</b></p><hr />';
  }
  if (isset($_SERVER['REDIRECT_URL'])) {
    echo '<p align="left">$_SERVER[\'REDIRECT_URL\'] : <b>'.$_SERVER['REDIRECT_URL'].'</b></p><hr />';
  }
  if (isset($_SERVER['SCRIPT_URL'])) {
    echo '<p align="left">$_SERVER[\'SCRIPT_URL\'] : <b>'.$_SERVER['SCRIPT_URL'].'</b></p><hr />';
  }

  if ($sp_debug_mode==='2'){
    $sape_host='dispenser-01.sape.ru';
    $path='/code.php?user='._SAPE_USER.'&host=' . $_SERVER['HTTP_HOST'];
    $user_agent='mod_sape Testing (http://soft.vomske.ru)';
    echo '<p align="left"> file_get_contents: <b>'.(function_exists('file_get_contents')==1?'':'').'</b></p>';
    echo '<p align="left"> file_get_contents allow_url_fopen: <b>'.(ini_get('allow_url_fopen')==1?'':'').'</b></p>';
    if (function_exists('file_get_contents')==1){
      $data = @file_get_contents('http://'.$sape_host.$path);
      echo '<p align="left">   file_get_contents: <b>'.($data?'':'').' - '.strlen($data).'</b></p>';
    }
    echo '<hr />';

    echo '<p align="left"> curl_init: <b>'.(function_exists('curl_init')==1?'':'').'</b></p>';
    if (function_exists('curl_init')==1){
      $data='';
      if ($ch = @curl_init()) {
        @curl_setopt($ch, CURLOPT_URL,              'http://' . $sape_host . $path);
        @curl_setopt($ch, CURLOPT_HEADER,           false);
        @curl_setopt($ch, CURLOPT_RETURNTRANSFER,   true);
        @curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,   30);
        @curl_setopt($ch, CURLOPT_USERAGENT,        $user_agent);
        $data = @curl_exec($ch);
        @curl_close($ch);
      }
      echo '<p align="left">   curl_init: <b>'.($data?'':'').' - '.strlen($data).'</b></p>';
    }
    echo '<hr />';

    echo '<p align="left"> fsockopen: <b>'.(function_exists('fsockopen')==1?'':'').'</b></p>';
    if (function_exists('fsockopen')==1){
      $data='';
      $buff = '';
      $fp = @fsockopen($sape_host, 80, $errno, $errstr, 30);
      if ($fp) {
        @fputs($fp, "GET {$path} HTTP/1.0\r\nHost: {$sape_host}\r\n");
        @fputs($fp, "User-Agent: {$user_agent}\r\n\r\n");
        while (!@feof($fp)) {
          $buff .= @fgets($fp, 128);
        }
        @fclose($fp);
        $page = explode("\r\n\r\n", $buff);
        $data=$page[1];
      }
      echo '<p align="left">   fsockopen: <b>'.($data?'':'').' - '.strlen($data).'</b></p>';
    }
    echo '<hr />';
  }
}
  unset($sape_option);

if ($sp_link_count==='0'){
  $echo_link=$mod_sape_return_links->return_links(); 
} else{
  $echo_link=$mod_sape_return_links->return_links($sp_link_count); 
}

if (($sp_hide_empty==='1') and preg_match("/^<!--.+-->$/",$echo_link) and (!(isset($_POST['sape_site_id']) and $_POST['sape_site_id']==$sp_sape_site_id))){
  $echo_link='';
}

if ($sp_show_header==='1'){
  if (preg_match("/^<!--.+-->$/",$echo_link) or trim($echo_link)===''){
    echo $echo_link;	
  } else{
    echo '<table cellpadding="0" cellspacing="0" class="moduletable'.$moduleclass_sfx.'"><tr><th valign="top">'.$module->title.'</th></tr>';
    echo '<tr><td>'.$echo_link.'</tr></td></table>';	
  }
}
else
{
  echo $echo_link;	
}
?>
